#include "sys.h"
#include "lex.h"

#define DEBUG FALSE

extern union token_value tok_val;
extern token_type token;

/*
        Parse an arithmetic expression
*/

void arith_expr()
{
        token_type eop, fop;

        t();

        while(token == '*' || token == '/')
        {
                fop = token;
                yylex();
                t();
#if DEBUG
                printf("%c\n", fop);
#endif
                code_op(fop);
        }

        while(token == '+' || token == '-')
        {
                eop = token;
                yylex();

                t();
                while(token == '*' || token == '/')
                {
                        fop = token;
                        yylex();
                        t();
#if DEBUG
                        printf("%c\n", fop);
#endif
                        code_op(fop);
                }
#if DEBUG
                printf("%c\n", eop);
#endif
                code_op(eop);
        }
}



/*
        Parse a term
*/
static void t()
{
        int negative_flag;

        negative_flag = (token == '-');
        if(token == '-' || token == '+') yylex();

        switch (token)
        {
                case '(':
                     yylex();
                     arith_expr();
                     if(token != ')') error("Closing paren expected");
                     else             yylex();
                     break;

                case NUMBER:
                     if(negative_flag)
                     {
                        tok_val.val = - tok_val.val;
                        negative_flag = FALSE;
                     }
                     code_push(tok_val.val);
#if DEBUG
  printf("push %lg\n", tok_val.val);
#endif
                     yylex();
                     break;

                case IDENT_TOK:
#if DEBUG
  printf("INDIRECT %u\n", tok_val.ptr);
#endif
                      code_indirect(tok_val.ptr);
                      yylex();
                      break;

                default:
                     error("Term expected");
                     break;
        }
        if(negative_flag)
        {
#if DEBUG
                printf("NEGATE\n");
#endif
                code_op(UN_MINUS);
        }
}
